totalEnt=0

--Entities
empty = {}
box = {}
player = {}
player.c_up=false
player.c_down=false
player.c_left=false
player.c_right=false

function entAdd(ent,x,y,w,h)
	if not ent then
		ent=empty
		print("Y U NO HAZ OBJECT?")
	end

	if not x then
		x=0
		print("Y U NO X VALUE?")
	end

	if not y then
		y=0
		print("Y U NO KNOW Y?")
	end

	if not w then
		w=0
		print("Y NO WIDTH?")
	end

	if not h then
		h=0
		print("Y NO HEIGHT?")
	end

	totalEnt=totalEnt+1
	newEnt = {}
	newEnt.id=totalEnt
	newEnt.x=x
	newEnt.y=y
	newEnt.w=w
	newEnt.h=h

	table.insert(ent,newEnt)
end

function entCollidePoint(ent,cx,cy)
	for i,v in ipairs(ent) do
		local xcheck = (cx > v.x and cx < v.x+v.w)
		local ycheck = (cy > v.y and cy < v.y+v.h)
		if xcheck and ycheck then
			return true
		end
	end
	return false
end

function love.load()
	entAdd(box,0,0,32,32)
	entAdd(box,32,0,32,32)
	entAdd(box,64,0,32,32)
	entAdd(box,96,0,32,32)
	entAdd(box,128,0,32,32)
	entAdd(box,160,0,32,32)
	entAdd(box,192,0,32,32)
	entAdd(box,224,0,32,32)

	entAdd(box,0,160,32,32)
	entAdd(box,32,160,32,32)
	entAdd(box,64,160,32,32)
	entAdd(box,96,160,32,32)
	entAdd(box,128,160,32,32)
	entAdd(box,160,160,32,32)
	entAdd(box,192,160,32,32)
	entAdd(box,224,160,32,32)

	entAdd(box,0,32,32,32)
	entAdd(box,0,64,32,32)
	entAdd(box,0,96,32,32)
	entAdd(box,0,128,32,32)

	entAdd(box,224,32,32,32)
	entAdd(box,224,64,32,32)
	entAdd(box,224,96,32,32)
	entAdd(box,224,128,32,32)

	entAdd(player,64,64,16,16)
end

function love.draw()
	for i,v in ipairs(box) do
		love.graphics.setColor(255,255,255,255)
	    love.graphics.rectangle("fill", v.x, v.y, v.w, v.h)
	    love.graphics.setColor(0, 0, 255)
	    love.graphics.rectangle("line", v.x, v.y, v.w, v.h)
	end

	for i,v in ipairs(player) do
		love.graphics.setColor(0,255,0,255)
		love.graphics.rectangle("fill", v.x, v.y, v.w, v.h)
	end

	love.graphics.setColor(255,0,0,255)
	love.graphics.print("While you have seen " .. love.timer.getFPS() .. " pictures this second,", 16, 16)
	love.graphics.print("I have emitted " .. totalEnt .. " entities. Go me!", 16, 32)
end

function love.update(dt)
	local vk_up = love.keyboard.isDown('up')
	local vk_down = love.keyboard.isDown('down')
	local vk_left = love.keyboard.isDown('left')
	local vk_right = love.keyboard.isDown('right')

	local speed = 4

	--PLAYER CODE
	for i,v in ipairs(player) do
		temp_x=v.x
		temp_y=v.y

		if vk_left and not entCollidePoint(box, v.x-speed, v.y) then
			v.x = v.x - speed
		end

		if vk_right and not entCollidePoint(box, v.x+v.w+speed, v.y) then
			v.x = v.x + speed
		end

		if vk_up and not entCollidePoint(box, v.x, v.y-speed) then
			v.y = v.y - speed
		end

		if vk_down and not entCollidePoint(box, v.x, v.y+v.h+speed) then
			v.y = v.y + speed
		end
	end
end

